package solatium.blockchain;

import javax.xml.bind.DatatypeConverter;
import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public final class Sha256Hash implements Hash {

    private final String input;

    public Sha256Hash(String data, String previousHash) {
        this.input = data + previousHash;
    }

    @Override
    public String getHash(){
        try {
            MessageDigest digest = MessageDigest.getInstance("SHA-256");
            byte[] hash = digest.digest(input.getBytes("UTF-8"));

            return DatatypeConverter.printHexBinary(hash);
        }
        catch(UnsupportedEncodingException | NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
    }

}
