package solatium.gui;

import solatium.auth.*;
import solatium.interfaces.*;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;

public class Login implements ActionListener {

    private JFrame frame;
    private JLabel errorMsg;
    private JTextField idField;
    private JTextField pwField;

    public Login() {
        frame = new JFrame();
        frame.setTitle("Login - Solatium");

        JPanel panel = new JPanel();
        frame.setContentPane(panel);
        frame.setVisible(true);

        JButton loginBtn = new JButton("Login");
        loginBtn.addActionListener(this);

        idField = new JTextField(20);
        pwField = new JTextField(20); // Maybe use JPasswordField?

        errorMsg = new JLabel();


        frame.add(idField);
        frame.add(pwField);
        frame.add(loginBtn);
        frame.add(errorMsg);

        frame.setSize(300, 125);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        Verification auth = new Verification(new UserDataBase());

        boolean isAuth = auth.verifiy(idField.getText(), pwField.getText());

        if(isAuth) {

            UserDataBase userDB = new UserDataBase();
            Customer user = userDB.getUser(idField.getText());

            new HomeScreen(user);

            frame.dispatchEvent(new WindowEvent(frame, WindowEvent.WINDOW_CLOSING));
        } else {
            errorMsg.setText("Nah Fam! Wrong Password");
        }
    }
}
