package solatium.gui;

import lombok.extern.slf4j.Slf4j;
import solatium.interfaces.Customer;
import solatium.interfaces.NotEnoughMoneyException;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.NumberFormat;

import static com.sun.org.apache.xalan.internal.xsltc.compiler.util.Type.Int;

@Slf4j
public class Transaction implements ActionListener {

    private Customer user;

    JFrame frame;
    JTextField recieverAddr;
    JFormattedTextField amount;
    JLabel errorMsg;


    public Transaction(Customer user) {
        this.user = user;
    }


    @Override
    public void actionPerformed(ActionEvent e) {
        frame = new JFrame();
        frame.setTitle("Transaction - Solatium");

        JPanel panel = new JPanel();
        frame.setContentPane(panel);
        frame.setVisible(true);

        JButton sendTransactionBtn = new JButton("Send Transaction");
        sendTransactionBtn.addActionListener(new SendTransaction());

        recieverAddr = new JTextField(20);
        amount = new JFormattedTextField(NumberFormat.getNumberInstance());
        amount.setValue(new Amount(0));
        amount.setColumns(20);

        errorMsg = new JLabel();

        frame.add(recieverAddr);
        frame.add(amount);
        frame.add(sendTransactionBtn);
        frame.add(errorMsg);

        frame.setSize(375, 150);

    }

    private class SendTransaction implements ActionListener {

        @Override
        public void actionPerformed(ActionEvent e) {

            int intAmount = new Amount(amount.getValue()).intValue();

            try {
                user.send(recieverAddr.getText(), intAmount);
            } catch (NotEnoughMoneyException error) {
                errorMsg.setText(error.getMessage());
            }


            log.info(user.getUserName() + " Sending " + intAmount + " Money Transaction From Address " + user.getAddress() + " to Address " + recieverAddr.getText());
        }
    }
}
