package solatium.interfaces;

import solatium.blockchain.Chain;
import solatium.blockchain.Transaction;

public class Bank implements User {

    private static final String address = "000000";
    private Balance balance;
    private final Chain blockChain;

    public Bank(Chain blockChain) {
        this.blockChain = blockChain;
        balance = new Balance(address, blockChain);
    }

    @Override
    public String getUserName() {
        return "Bank";
    }

    @Override
    public String getAddress() {
        return address;
    }

    @Override
    public String getPassword() {
        return "";
    }

    @Override
    public int getErrorCounter() {
        return 0;
    }

    @Override
    public int addErrorCounter() {
        return 0;
    }

    @Override
    public boolean isBlocked() {
        return false;
    }

    @Override
    public int getBalance() {
        return balance.updateBalance().getBalance();
    }

    @Override
    public void send(String receiverAddress, int amount) {
        Transaction transaction = new Transaction(address, receiverAddress, amount);
        blockChain.addToChain(transaction);
    }
}
