package solatium.interfaces;

import org.junit.Test;
import solatium.blockchain.BlockChain;
import solatium.blockchain.Chain;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;

public class BankTest {

    @Test
    public void shouldConstructCorrect() {
        User bank = new Bank(new BlockChain());
        assertEquals("Bank", bank.getUserName());
        assertEquals("", bank.getPassword());
        assertEquals("000000", bank.getAddress());
        assertEquals(0, bank.getErrorCounter());
        assertEquals(0, bank.addErrorCounter());
        assertFalse(bank.isBlocked());
        assertEquals(0, bank.getBalance());
    }

    @Test
    public void shouldSendEvenIfBalanceNegative() {
        Chain blockChain = new BlockChain();
        User bank = new Bank(blockChain);
        assertEquals(0, bank.getBalance());
        bank.send("foo", 100);
        assertEquals(-100, bank.getBalance());

        bank.send("foo", 100);
        assertEquals(-200, bank.getBalance());
    }

}